import Book;
import Author;
import Text;
import java.io.*;
import java.util.Vector;

public class LargeLibrary {

  private Vector Books = new Vector();
  private int Current;

  // PRE  TRUE
  // POST this' is this with NewBook added
  public void Add_Book(Book NewBook) {

    Books.addElement(NewBook);
  }

  // PRE  TRUE
  // POST IF this is empty
  //        RETURNS TRUE
  //      ELSE
  //        RETURNS FALSE
  public boolean Q_Empty() {

    return(Books.isEmpty());
  }

  // PRE  TRUE
  // POST RETURNS String representation of this
  public String toString() {
    int i;
    int Size = Books.size();
    String Result = "";

    for (i = 0; i < Size; i++) {
      Result = Result + "\nBOOK NUMBER " + (i + 1) + "\n" + Books.elementAt(i).toString();
    }
    return(Result);
  }

  // PRE  TRUE
  // POST IF book with author Name and Initials in this
  //        RETURNS TRUE
  //      ELSE
  //        RETURNS FALSE
  public boolean Q_Author_Present(String Name, Initials Inits) {
    int i;
    int Size = Books.size();
    Book NextB;
    Author NextA;

    for (i = 0; i < Size; i++) {
      NextB = (Book) Books.elementAt(i);
      NextA = NextB.Get_Author();
      if (NextA.Q_Author_Id(Name, Inits)) {
        return(true);
      }
    }
    return(false);
  }

  // PRE  NOT Q_Empty
  // POST First element in this' is current element
  public void Go_To_Start() {

    Current = 0;
  }

  // PRE  NOT Q_Empty()
  // POST IF current element is last
  //        RETURNS TRUE
  //      ELSE
  //        RETURNS FALSE
  public boolean Q_AtEnd() {

    return(Current >= (Books.size() - 1));
  }

  // PRE  NOT Q_Empty
  // POST RETURNS current element
  public Book Get_Current() {
    return((Book) Books.elementAt(Current));
  }

  // PRE  NOT Q_AtEnd
  // POST Current element of this' is the one after current of this
  public void Go_To_Next() {

    Current++;
  }
}

