import Book;
import NonFict;
import Loanable;
import Reference;
import DVD;
import Author;
import Text;
import java.io.*;
import java.util.Vector;
import LargeLibrary;

public class Main {

  private LargeLibrary Books = new LargeLibrary();
  private BufferedReader In = new BufferedReader(new InputStreamReader(System.in));


  // PRE  TRUE
  // POST User prompted for author surname and initials
  //      IF author has book in database
  //        message to say so
  //      ELSE
  //        message to say not
  private void User_Check_Author_Present() {
    String Name;
    Initials Inits;

    System.out.print("Please enter author surname ==> ");
    Name = Text.ReadString(In);
    System.out.print("Please enter author initials ==> ");
    Inits = new Initials(In);
    if (Books.Q_Author_Present(Name, Inits)) {
      System.out.println("Author present");
    }
    else {
      System.out.println("Author not present");
    }
  }

  // PRE  TRUE
  // POST Prints author menu
  private void Author_Menu() {
    System.out.println("Check (a)uthor present");
  }

  // PRE  TRUE
  // POST Goes into prompt/execute loop for authors
  public void User_Author_Options() {
    char Option;

    Author_Menu();
    System.out.print("\n\nNext option ===>");
    Option = Text.ReadChar(In);
    switch (Option) {
	    case 'a':
        User_Check_Author_Present();
  	  break;

  		default:
        System.out.println("Option " + Option + " not recognised");
			break;
    }
    System.out.println("Returning to main menu options - m for menu");
  }

  // PRE  TRUE
  // POST User prompted for fiction book details
  //      IF these are valid
  //        book added to database
  //      ELSE
  //        message to say not valid
  public void User_Enter_Fiction() {
    Author A;
    int GenNum;
    Genre G;

    System.out.println("Please enter author details");
    A = new Author(In);
    System.out.println("Please enter genre details");
    System.out.println("Genres are " + Genre.Get_GenresString());
    System.out.print("Please enter genre number ==> ");
    GenNum = Text.ReadInt(In);
    if (Genre.Q_InRange(GenNum)) {
      G = Genre.Get_Genre(GenNum);
      Books.Add_Book(new Fiction(A, G, In));
    }
    else {
      System.out.println(GenNum + " is not a valid genre number");
    }
  }

  // PRE  TRUE
  // POST User prompted for loanable book details
  //      IF these are valid
  //        book added to database
  //      ELSE
  //        message to say not valid
  public void User_Enter_Loanable() {
    Author A;

    System.out.println("Please enter author details");
    A = new Author(In);
    Books.Add_Book(new Loanable(A, In));
  }

  // PRE  TRUE
  // POST All books in database printed out
  private void User_Print_All_Books() {
    if (!Books.Q_Empty()) {
      System.out.println("Books as follows\n" + Books.toString());
    }
    else {
      System.out.println("No books!\n");
    }
  }

  // PRE  NOT Books.Q_Empty()
  // POST IF Books.Get_Current() is loanable
  //        Books.Get_Current() is printed to screen
  private void PrintCurrent_If_Loanable() {
    Book NextB;
    NonFict NextNF;
    Loanable NextL;

    NextB = Books.Get_Current();
    if (NextB.Q_NonFict()) {
      NextNF = (NonFict) NextB;
      if (NextNF.Q_Loanable()) {
        System.out.println(NextB.toString());
      }
    }
  }

  // PRE  NOT Books.Q_Empty()
  // POST All loanable books in database printed to screen
  private void User_Print_All_Loanables() {

    if (!Books.Q_Empty()) {
      Books.Go_To_Start();
      for(;!Books.Q_AtEnd();) {
        PrintCurrent_If_Loanable();
        Books.Go_To_Next();
      }
      PrintCurrent_If_Loanable();
    }
  }

  // PRE  TRUE
  // POST Prints book menu
  private void Book_Menu() {
    System.out.println("Read in (f)iction details");
    System.out.println("Read in (l)oanable non-fiction details");
    System.out.println("Read in (r)eference non-fiction details");
    System.out.println("Print all (b)ooks");
    System.out.println("Print all lo(a)nables");
  }

  // PRE  TRUE
  // POST Goes into prompt/execute loop for authors
  public void User_Book_Options() {
    char Option;

    Book_Menu();
    System.out.print("\n\nNext option ===>");
    Option = Text.ReadChar(In);
    switch (Option) {
	    case 'f':
        User_Enter_Fiction();
  	  break;

	    case 'l':
        User_Enter_Loanable();
  	  break;

	    case 'b':
        User_Print_All_Books();
  	  break;

	    case 'a':
        User_Print_All_Loanables();
  	  break;

  		default:
        System.out.println("Option " + Option + " not recognised");
			break;
    }
    System.out.println("Returning to main menu options - m for menu");
  }

  // PRE  TRUE
  // POST Prints main menu
  private void Main_Menu() {
    System.out.println("\n(b)ook menu");
    System.out.println("(a)uthor menu");
    System.out.println("(m) This menu");
    System.out.println("(x) Exit");
  }

  // PRE  TRUE
  // POST Goes into prompt/execute main loop
  public void Loop() {
    char Option;

  	for (Option = 'm'; Option != 'x';) {

		  switch (Option) {
			  case 'b':
          User_Book_Options();
  			break;

			  case 'a':
          User_Author_Options();
  			break;

			  case 'm':
          Main_Menu();
  			break;

  		  default:
          System.out.println("Option " + Option + " not recognised");
          Main_Menu();
			  break;
      }
		  System.out.print("\n\nNext option ===>");
      Option = Text.ReadChar(In);
    }
  }

	public static void main(String[] args) {
    Main M = new Main();
    M.Loop();
  }
}

