import java.io.*;
import Text;

public class Reference extends NonFict {

  private static String[] RefRooms = {"Main Hall", "Tower", "Grafton Annexe"};

  // PRE  TRUE
  // POST Displays reference rooms and numbers
  public static void Display_RefRooms() {
    int i;

    for (i = 0; i < RefRooms.length; i++) {
      System.out.println(RefRooms[i] + " is number " + i);
    }
  }

  // PRE  TRUE
  // POST IF Num is valid for reference room
  //        RETURNS TRUE
  //      ELSE
  //        RETURNS FALSE
  public static boolean Q_ValidRRNum(int Num) {

    return(((Num >= 0) && (Num < RefRooms.length)));
  }



  private int RefRoom;
  private boolean Q_RefRoomSet = false;

  // PRE  TRUE
  // POST Prompts user for details other than Author
  //      and RETURNS new Reference constructed from details
  public Reference(Author Author, BufferedReader In) {

    super(Author, In);
  }

  // PRE  TRUE
  // POST this allocated to reference room
  public void Set_Reference_Room(int RefRoom) {

    this.RefRoom = RefRoom;
    Q_RefRoomSet = true;
  }

  public boolean Q_Reference() {

    return(true);
  }


  // PRE  TRUE
  // POST RETURNS String representation this
  public String toString() {
    String Result;

    Result = super.toString();
    if (Q_RefRoomSet) {
      Result = Result + "\nReference room : " + RefRooms[RefRoom];
    }
    return(Result);
  }
}

